// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Fixtures.AcceptanceTestsParameterFlattening
{
    using System.Threading.Tasks;
   using Models;

    /// <summary>
    /// Extension methods for AvailabilitySets.
    /// </summary>
    public static partial class AvailabilitySetsExtensions
    {
            /// <summary>
            /// Updates the tags for an availability set.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='avset'>
            /// The name of the storage availability set.
            /// </param>
            /// <param name='tags'>
            /// A set of tags. A description about the set of tags.
            /// </param>
            public static void Update(this IAvailabilitySets operations, string resourceGroupName, string avset, System.Collections.Generic.IDictionary<string, string> tags)
            {
                System.Threading.Tasks.Task.Factory.StartNew(s => ((IAvailabilitySets)s).UpdateAsync(resourceGroupName, avset, tags), operations, System.Threading.CancellationToken.None, System.Threading.Tasks.TaskCreationOptions.None,  System.Threading.Tasks.TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
            }

            /// <summary>
            /// Updates the tags for an availability set.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='resourceGroupName'>
            /// The name of the resource group.
            /// </param>
            /// <param name='avset'>
            /// The name of the storage availability set.
            /// </param>
            /// <param name='tags'>
            /// A set of tags. A description about the set of tags.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async System.Threading.Tasks.Task UpdateAsync(this IAvailabilitySets operations, string resourceGroupName, string avset, System.Collections.Generic.IDictionary<string, string> tags, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
            {
                await operations.UpdateWithHttpMessagesAsync(resourceGroupName, avset, tags, null, cancellationToken).ConfigureAwait(false);
            }

    }
}
